{-
File: AssociationList.hs

Author: Ken Lambert

Purpose: provides a AssociationList data type

-}

module AssociationList (newAssociationList, findKey, addKey, removeKey) where

data AssociationList = AssociationList [(String,String)]
    deriving Show

newAssociationList ::  AssociationList
newAssociationList = AssociationList []

findKey ::  String -> AssociationList -> Maybe String
findKey key (AssociationList list) = helper list
    where
    helper :: [(String, String)] -> Maybe String
    helper [] = Nothing
    helper ((k,v):pairs)
       | key == k = Just v
       | otherwise = helper pairs
        
addKey :: String -> String -> AssociationList -> AssociationList
addKey key newValue (AssociationList list) = AssociationList (helper list) 
    where
    helper :: [(String, String)] -> [(String, String)]
    helper [] = [(key, newValue)]
    helper ((k,v):pairs)
        | key == k = (k, newValue) : pairs
        | otherwise = (k,v) : helper pairs
    
removeKey ::String -> AssociationList -> AssociationList
removeKey key (AssociationList list) = AssociationList (helper list)
    where
    helper :: [(String, String)] -> [(String, String)]
    helper [] = []
    helper ((k,v):pairs)
        | key == k = pairs
        | otherwise = (k,v) : helper pairs


