{-
File: Employee.hs
-}

module Employee where

import HoursWorked (Day, HoursWorked, newHours)
import qualified HoursWorked (setHoursForDay, totalHours)

data Employee = Employee String Float HoursWorked
                deriving Show

newEmployee :: String -> Float -> Employee
newEmployee name payRate = Employee name payRate newHours

employeeName :: Employee -> String
employeeName (Employee name _ _) = name

employeePayRate :: Employee -> Float
employeePayRate (Employee _ payRate _) = payRate

setEmployeePayRate :: Float -> Employee -> Employee
setEmployeePayRate newPayRate (Employee name _ hours) = 
    Employee name newPayRate hours

setHoursForDay :: Day -> Float -> Employee -> Employee
setHoursForDay day newHours (Employee name payRate hours) = 
    Employee name payRate (HoursWorked.setHoursForDay day 
    newHours hours)

totalHours :: Employee -> Float
totalHours (Employee _ _ hours) = HoursWorked.totalHours hours

totalPay :: Employee -> Float
totalPay employee = employeePayRate employee * totalHours employee