{-
File: HoursWorked.hs
-}

module HoursWorked where

data Day = Monday | Tuesday | Wednesday | Thursday | Friday | 
           Saturday | Sunday
           deriving (Enum, Eq, Ord, Read, Show)

type HoursWorked = [(Day, Float)]

newHours :: HoursWorked
newHours = map (\day -> (day, 0)) [Monday .. Sunday]

hoursForDay :: Day -> HoursWorked -> Float
hoursForDay day ((d,h):xs)
    | day == d = h
    | otherwise = hoursForDay day xs

setHoursForDay :: Day -> Float -> HoursWorked -> HoursWorked
setHoursForDay day newHours ((d,h):xs)
    | day == d = (d,newHours) : xs
    | otherwise = (d,h) : setHoursForDay day newHours xs

totalHours :: HoursWorked -> Float
totalHours hr = foldr (\ (d,h) total -> h + total) 0.0 hr
