{-
File: NumberLines.hs
-}
    
module Main (main) where

import Data.String (lines, unlines)
import TerminalIO (getString)

numberLines :: [Char] -> [Char]
numberLines text = unlines (helper (lines text) 1) where
    helper :: [[Char]] -> Int -> [[Char]]    
    helper [] _ = []
    helper (x:xs) count = 
        (show count ++ " " ++ x) : helper xs (count + 1)

main :: IO ()
main = do
    inputPathname <- getString "Enter the input file name: "
    outputPathname <- getString "Enter the input file name: "
    if inputPathname == outputPathname then do
        putStrLn "Error: files must have different names"
        return ()
    else do
        inputText <- readFile inputPathname
        let outputText = numberLines inputText
        writeFile outputPathname outputText