{-
File: TailRecurse.hs

Author: Ken Lambert

An example of a tail-recursive function.  A tail-recursive functiomn does
no work after any recursive calls.

-}

module TailRecurse where

-- Function to compute the factorial of an integer
-- Includes a locally defined function with tail recursion

factorial :: Integer -> Integer
factorial n = fact_iter n 1
    where
        fact_iter :: Integer -> Integer -> Integer
        fact_iter 0 result = result
        fact_iter n result = fact_iter (n - 1) (n * result)