{-
File: TerminalIO.hs

Purpose: Terminal-based input functions
-}

module TerminalIO (getFloat, getInt, getString) where

import System.IO

-- Interactive nput functions for floats, ints, and strings

-- Each function displays a prompt and waits for input

getFloat :: String -> IO Float
getFloat prompt = do
    inputString <- getString prompt
    return (read inputString :: Float)
    
getInt :: String -> IO Int
getInt prompt = do
    inputString <- getString prompt
    return (read inputString :: Int)

getString :: String -> IO String
getString prompt = do
    putStr prompt
    hFlush stdout
    inputString <- getLine
    return inputString
    
-- For output, use putStr or putStrLn, with show for numbers